/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource model definition for a Azure Resource Manager resource with an
 * etag.
 *
 * @extends models['Resource']
 */
class AzureEntityResource extends models['Resource'] {
  /**
   * Create a AzureEntityResource.
   * @property {string} [etag] Resource Etag.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureEntityResource
   *
   * @returns {object} metadata of AzureEntityResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureEntityResource',
      type: {
        name: 'Composite',
        className: 'AzureEntityResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureEntityResource;
