/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The blob service properties for soft delete.
 *
 */
class DeleteRetentionPolicy {
  /**
   * Create a DeleteRetentionPolicy.
   * @property {boolean} [enabled] Indicates whether DeleteRetentionPolicy is
   * enabled for the Blob service.
   * @property {number} [days] Indicates the number of days that the deleted
   * blob should be retained. The minimum specified value can be 1 and the
   * maximum value can be 365.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeleteRetentionPolicy
   *
   * @returns {object} metadata of DeleteRetentionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeleteRetentionPolicy',
      type: {
        name: 'Composite',
        className: 'DeleteRetentionPolicy',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          days: {
            required: false,
            serializedName: 'days',
            constraints: {
              InclusiveMaximum: 365,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DeleteRetentionPolicy;
