/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A list of services that support encryption.
 *
 */
class EncryptionServices {
  /**
   * Create a EncryptionServices.
   * @property {object} [blob] The encryption function of the blob storage
   * service.
   * @property {boolean} [blob.enabled] A boolean indicating whether or not the
   * service encrypts the data as it is stored.
   * @property {date} [blob.lastEnabledTime] Gets a rough estimate of the
   * date/time when the encryption was last enabled by the user. Only returned
   * when encryption is enabled. There might be some unencrypted blobs which
   * were written after this time, as it is just a rough estimate.
   * @property {object} [file] The encryption function of the file storage
   * service.
   * @property {boolean} [file.enabled] A boolean indicating whether or not the
   * service encrypts the data as it is stored.
   * @property {date} [file.lastEnabledTime] Gets a rough estimate of the
   * date/time when the encryption was last enabled by the user. Only returned
   * when encryption is enabled. There might be some unencrypted blobs which
   * were written after this time, as it is just a rough estimate.
   * @property {object} [table] The encryption function of the table storage
   * service.
   * @property {boolean} [table.enabled] A boolean indicating whether or not
   * the service encrypts the data as it is stored.
   * @property {date} [table.lastEnabledTime] Gets a rough estimate of the
   * date/time when the encryption was last enabled by the user. Only returned
   * when encryption is enabled. There might be some unencrypted blobs which
   * were written after this time, as it is just a rough estimate.
   * @property {object} [queue] The encryption function of the queue storage
   * service.
   * @property {boolean} [queue.enabled] A boolean indicating whether or not
   * the service encrypts the data as it is stored.
   * @property {date} [queue.lastEnabledTime] Gets a rough estimate of the
   * date/time when the encryption was last enabled by the user. Only returned
   * when encryption is enabled. There might be some unencrypted blobs which
   * were written after this time, as it is just a rough estimate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionServices
   *
   * @returns {object} metadata of EncryptionServices
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionServices',
      type: {
        name: 'Composite',
        className: 'EncryptionServices',
        modelProperties: {
          blob: {
            required: false,
            serializedName: 'blob',
            type: {
              name: 'Composite',
              className: 'EncryptionService'
            }
          },
          file: {
            required: false,
            serializedName: 'file',
            type: {
              name: 'Composite',
              className: 'EncryptionService'
            }
          },
          table: {
            required: false,
            readOnly: true,
            serializedName: 'table',
            type: {
              name: 'Composite',
              className: 'EncryptionService'
            }
          },
          queue: {
            required: false,
            readOnly: true,
            serializedName: 'queue',
            type: {
              name: 'Composite',
              className: 'EncryptionService'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionServices;
