/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The URIs that are used to perform a retrieval of a public blob, queue,
 * table, web or dfs object.
 *
 */
class Endpoints {
  /**
   * Create a Endpoints.
   * @property {string} [blob] Gets the blob endpoint.
   * @property {string} [queue] Gets the queue endpoint.
   * @property {string} [table] Gets the table endpoint.
   * @property {string} [file] Gets the file endpoint.
   * @property {string} [web] Gets the web endpoint.
   * @property {string} [dfs] Gets the dfs endpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Endpoints
   *
   * @returns {object} metadata of Endpoints
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Endpoints',
      type: {
        name: 'Composite',
        className: 'Endpoints',
        modelProperties: {
          blob: {
            required: false,
            readOnly: true,
            serializedName: 'blob',
            type: {
              name: 'String'
            }
          },
          queue: {
            required: false,
            readOnly: true,
            serializedName: 'queue',
            type: {
              name: 'String'
            }
          },
          table: {
            required: false,
            readOnly: true,
            serializedName: 'table',
            type: {
              name: 'String'
            }
          },
          file: {
            required: false,
            readOnly: true,
            serializedName: 'file',
            type: {
              name: 'String'
            }
          },
          web: {
            required: false,
            readOnly: true,
            serializedName: 'web',
            type: {
              name: 'String'
            }
          },
          dfs: {
            required: false,
            readOnly: true,
            serializedName: 'dfs',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Endpoints;
