/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The ImmutabilityPolicy property of a blob container, including Id, resource
 * name, resource type, Etag.
 *
 * @extends models['AzureEntityResource']
 */
class ImmutabilityPolicy extends models['AzureEntityResource'] {
  /**
   * Create a ImmutabilityPolicy.
   * @property {number} immutabilityPeriodSinceCreationInDays The immutability
   * period for the blobs in the container since the policy creation, in days.
   * @property {string} [state] The ImmutabilityPolicy state of a blob
   * container, possible values include: Locked and Unlocked. Possible values
   * include: 'Locked', 'Unlocked'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ImmutabilityPolicy
   *
   * @returns {object} metadata of ImmutabilityPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImmutabilityPolicy',
      type: {
        name: 'Composite',
        className: 'ImmutabilityPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          immutabilityPeriodSinceCreationInDays: {
            required: true,
            serializedName: 'properties.immutabilityPeriodSinceCreationInDays',
            type: {
              name: 'Number'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'properties.state',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImmutabilityPolicy;
