/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Management policy action for base blob.
 *
 */
class ManagementPolicyBaseBlob {
  /**
   * Create a ManagementPolicyBaseBlob.
   * @property {object} [tierToCool] The function to tier blobs to cool
   * storage. Support blobs currently at Hot tier
   * @property {number} [tierToCool.daysAfterModificationGreaterThan] Integer
   * value indicating the age in days after last modification
   * @property {object} [tierToArchive] The function to tier blobs to archive
   * storage. Support blobs currently at Hot or Cool tier
   * @property {number} [tierToArchive.daysAfterModificationGreaterThan]
   * Integer value indicating the age in days after last modification
   * @property {object} [deleteProperty] The function to delete the blob
   * @property {number} [deleteProperty.daysAfterModificationGreaterThan]
   * Integer value indicating the age in days after last modification
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementPolicyBaseBlob
   *
   * @returns {object} metadata of ManagementPolicyBaseBlob
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementPolicyBaseBlob',
      type: {
        name: 'Composite',
        className: 'ManagementPolicyBaseBlob',
        modelProperties: {
          tierToCool: {
            required: false,
            serializedName: 'tierToCool',
            type: {
              name: 'Composite',
              className: 'DateAfterModification'
            }
          },
          tierToArchive: {
            required: false,
            serializedName: 'tierToArchive',
            type: {
              name: 'Composite',
              className: 'DateAfterModification'
            }
          },
          deleteProperty: {
            required: false,
            serializedName: 'delete',
            type: {
              name: 'Composite',
              className: 'DateAfterModification'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementPolicyBaseBlob;
