/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters limit rule actions to a subset of blobs within the storage account.
 * If multiple filters are defined, a logical AND is performed on all filters.
 *
 */
class ManagementPolicyFilter {
  /**
   * Create a ManagementPolicyFilter.
   * @property {array} [prefixMatch] An array of strings for prefixes to be
   * match.
   * @property {array} blobTypes An array of predefined enum values. Only
   * blockBlob is supported.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementPolicyFilter
   *
   * @returns {object} metadata of ManagementPolicyFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementPolicyFilter',
      type: {
        name: 'Composite',
        className: 'ManagementPolicyFilter',
        modelProperties: {
          prefixMatch: {
            required: false,
            serializedName: 'prefixMatch',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          blobTypes: {
            required: true,
            serializedName: 'blobTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementPolicyFilter;
