/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Storage Account ManagementPolicies Rules. See more details in:
 * https://docs.microsoft.com/en-us/azure/storage/common/storage-lifecycle-managment-concepts.
 *
 */
class ManagementPolicySchema {
  /**
   * Create a ManagementPolicySchema.
   * @property {array} rules The Storage Account ManagementPolicies Rules. See
   * more details in:
   * https://docs.microsoft.com/en-us/azure/storage/common/storage-lifecycle-managment-concepts.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementPolicySchema
   *
   * @returns {object} metadata of ManagementPolicySchema
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementPolicySchema',
      type: {
        name: 'Composite',
        className: 'ManagementPolicySchema',
        modelProperties: {
          rules: {
            required: true,
            serializedName: 'rules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ManagementPolicyRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'ManagementPolicyRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementPolicySchema;
