/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A tag of the LegalHold of a blob container.
 *
 */
class TagProperty {
  /**
   * Create a TagProperty.
   * @property {string} [tag] The tag value.
   * @property {date} [timestamp] Returns the date and time the tag was added.
   * @property {string} [objectIdentifier] Returns the Object ID of the user
   * who added the tag.
   * @property {string} [tenantId] Returns the Tenant ID that issued the token
   * for the user who added the tag.
   * @property {string} [upn] Returns the User Principal Name of the user who
   * added the tag.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TagProperty
   *
   * @returns {object} metadata of TagProperty
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagProperty',
      type: {
        name: 'Composite',
        className: 'TagProperty',
        modelProperties: {
          tag: {
            required: false,
            readOnly: true,
            serializedName: 'tag',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            readOnly: true,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          objectIdentifier: {
            required: false,
            readOnly: true,
            serializedName: 'objectIdentifier',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          upn: {
            required: false,
            readOnly: true,
            serializedName: 'upn',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TagProperty;
